/* This is the default configuration file to read -*- C -*- */

/* these are defined by automake */
#undef PACKAGE
#undef VERSION

#undef HAVE_LIBDL

#undef HAVE_STRUCT_FLOCK
#undef HAVE_TM_GMTOFF

#define CONFIGURATION_FILE_PATH "php.ini"
#define USE_CONFIG_FILE 1

#undef HAVE_DMALLOC

/* Some global constants defined by conigure */
#undef PHP_BUILD_DATE
#undef PHP_OS
#undef PHP_UNAME 

/* define uint by configure if it is missed (QNX and BSD derived) */
#undef uint

/* define ulong by configure if it is missed (most probably is) */
#undef ulong

/* type check for in_addr_t */
#undef in_addr_t

/* Define if you have dirent.h but opendir() resides in libc rather than in libdir */
/* This will cause HAVE_DIRENT_H defined twice sometimes, but it should be problem */
#undef HAVE_DIRENT_H

/* Define if you have the resolv library (-lresolv). */
#undef HAVE_LIBRESOLV

/* Define if you have the pam library (-lpam). */
#define HAVE_LIBPAM 0

/* Define if you have the bind library (-lbind). */
#define HAVE_LIBBIND 0

/* Define if you have Netscape LDAP instead of umich ldap or openldap*/
#define HAVE_NSLDAP 0

/* Define if you want safe mode enabled by default. */
#define PHP_SAFE_MODE 0

/* Set to the path to the dir containing safe mode executables */
#define PHP_SAFE_MODE_EXEC_DIR /usr/local/php/bin

/* Define if PHP to setup it's own SIGCHLD handler */
#define PHP_SIGCHILD 0

/* Define if you want POST/GET/Cookie track variables by default */
#define PHP_TRACK_VARS 0

/* Undefine if you want stricter XML/SGML compliance by default */
/* (this disables "<?expression?>" by default) */
#define DEFAULT_SHORT_OPEN_TAG 1

/* Undefine if you do not want PHP by default to escape "'" */
/* in GET/POST/Cookie data */
#define MAGIC_QUOTES 1

/* Define both of these if you want the bundled REGEX library */
#define REGEX 0
#define HSREGEX 0

/* Define if you have and want to use libnsl */
#undef HAVE_LIBNSL

/* Define if you have and want to use libsocket */
#undef HAVE_LIBSOCKET

/* Define if you have the sendmail program available */
#define HAVE_SENDMAIL 0

/* Define if you are compiling PHP as an Apache module with mod_charset patch applied (aka Russian Apache)*/
#define USE_TRANSFER_TABLES 0

/* Define if you are compiling PHP as an fhttpd module */
#define FHTTPD 0

/* Define if your Apache creates an ap_config.h header file (only 1.3b6 and later) */
#define HAVE_AP_CONFIG_H 0

/* Define if your Apache has src/include/compat.h */
#define HAVE_OLD_COMPAT_H 0

/* Define if your Apache has src/include/ap_compat.h */
#define HAVE_AP_COMPAT_H 0

/* Define if you want to enable PHP RPC (experimental) */
#define PHP_RPC 0

/* Define if you want to prevent the CGI from working unless REDIRECT_STATUS is defined in the environment */
#define FORCE_CGI_REDIRECT 0

/* Define if you want to prevent the CGI from using path_info and path_translated */
#define DISCARD_PATH 0

/* Define if you want include() and other functions to be able to open
 * http and ftp URLs as files.
 */
#define PHP_URL_FOPEN 0

/* Define if you have broken header files like SunOS 4 */
#define MISSING_FCLOSE_DECL 0

/* Define to compile PHP/Zend thread safe */
#undef ZTS

/* Define when compiling with Zeus support */
#undef WITH_ZEUS

/* Define if struct sockaddr contains the field sa_len */
#undef HAVE_SOCKADDR_SA_LEN

#undef BROKEN_SPRINTF

#if BROKEN_SPRINTF
#define sprintf php_sprintf
#endif
#define ZEND_API
#define ZEND_DLEXPORT

@TOP@

/* This is the default configuration file to read */
#define USE_CONFIG_FILE 1

/* these are defined by automake */
#undef PACKAGE
#undef VERSION

/* define uint by configure if it is missed (QNX and BSD derived) */
#undef uint

/* define ulong by configure if it is missed (most probably is) */
#undef ulong

/* Undefine if you want stricter XML/SGML compliance by default */
/* (this disables "<?expression?>" by default) */
#define T_DEFAULT_SHORT_OPEN_TAG 1

/* Define both of these if you want the bundled REGEX library */
#define REGEX 0
#define HSREGEX 0

#undef ZEND_DEBUG

/* Define if you want to enable memory limit support */
#define MEMORY_LIMIT 0

/* Define to compile Zend thread safe */
#undef ZTS

#undef HAVE_LIBDL

@BOTTOM@

#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#ifdef HAVE_STRING_H
# include <string.h>
#else
# include <strings.h>
#endif

/* Define if you have stdiostream.h */
#undef HAVE_STDIOSTREAM_H

#if ZEND_BROKEN_SPRINTF
int zend_sprintf(char *buffer, const char *format, ...);
#else
# define zend_sprintf sprintf
#endif

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
#undef PTHREADS
